﻿using System.IO;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace Wpf_TreeView
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Popular(string header, string tag, TreeView _root, TreeViewItem _child, bool isfile)
        {
            TreeViewItem driveItem = new TreeViewItem();
            driveItem.Tag = tag;
            driveItem.Header = header;
            driveItem.Expanded += new RoutedEventHandler(driveItem_Expanded);
            if (!isfile)
                driveItem.Items.Add(new TreeViewItem());

            if (_root != null)
            { _root.Items.Add(driveItem); }
            else { _child.Items.Add(driveItem); }
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            //Obtém os drives do computador
            foreach (DriveInfo driv in DriveInfo.GetDrives())
            {
                if (driv.IsReady)
                    Popular(driv.VolumeLabel + "(" + driv.Name + ")", driv.Name, folders, null, false);
            }
        }

        void driveItem_Expanded(object sender, RoutedEventArgs e)
        {
            TreeViewItem _item = (TreeViewItem)sender;
            if (_item.Items.Count == 1 && ((TreeViewItem)_item.Items[0]).Header == null)
            {
                _item.Items.Clear();
                foreach (string dir in Directory.GetDirectories(_item.Tag.ToString()))
                {
                    DirectoryInfo _dirinfo = new DirectoryInfo(dir);
                    Popular(_dirinfo.Name, _dirinfo.FullName, null, _item, false);
                }

                foreach (string dir in Directory.GetFiles(_item.Tag.ToString()))
                {
                    FileInfo _dirinfo = new FileInfo(dir);
                    Popular(_dirinfo.Name, _dirinfo.FullName, null, _item, true);
                }
            }
        }

        private void folders_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            if (e.Source is TreeViewItem && ((TreeViewItem)e.Source).IsSelected)
            {
                //seu tratamento aqui
            }
        }
    }
}
